unit RgnEdit;
{ *************************************************
  *            FormRgn library 04.05.99           *
  *           written by Grigoriev Anton          *
  *                                               *
  *                Property editor                *
  ************************************************* }

 interface

  uses Windows,Messages,SysUtils,Classes,Graphics,Controls,Forms,Dialogs,StdCtrls,Buttons,Clipbrd,Menus,DsgnIntf;

   type TRegionProperty=class(TStringProperty)
                         public
                          function GetAttributes:TPropertyAttributes;override;
                          procedure Edit;override;
                        end;

        TRgnEditDlg=class(TForm)
                     LBox:TListBox;
                     BtnRect:TBitBtn;
                     BtnEll:TBitBtn;
                     BtnRRect:TBitBtn;
                     BtnPoly:TBitBtn;
                     BtnOR:TBitBtn;
                     BtnAND:TBitBtn;
                     BtnXOR:TBitBtn;
                     BtnDiff:TBitBtn;
                     BtnSave:TBitBtn;
                     BtnLoad:TBitBtn;
                     BtnOK:TBitBtn;
                     BtnCancel:TBitBtn;
                     BtnBra:TBitBtn;
                     SDialog:TSaveDialog;
                     ODialog:TOpenDialog;
                     PopupMenu:TPopupMenu;
                     ItemText:TMenuItem;
                     ItemString:TMenuItem;
                     ItemSave:TMenuItem;
                     ItemOpen:TMenuItem;
                     N1:TMenuItem;
                     ItemRect:TMenuItem;
                     ItemEllipse:TMenuItem;
                     ItemRound:TMenuItem;
                     ItemPolygon:TMenuItem;
                     N2:TMenuItem;
                     OpeartionOR1:TMenuItem;
                     OperationAND1:TMenuItem;
                     OperationXOR1:TMenuItem;
                     OperationDiff1:TMenuItem;
                     N3:TMenuItem;
                     ItemBlock:TMenuItem;
                     BtnExt:TBitBtn;
                     BtnEdit:TBitBtn;
                     ItemExt:TMenuItem;
                     procedure LBoxDrawItem(Control:TWinControl;Index:Integer;Rect:TRect;State:TOwnerDrawState);
                     procedure BtnORClick(Sender:TObject);
                     procedure BtnANDClick(Sender:TObject);
                     procedure BtnXORClick(Sender:TObject);
                     procedure BtnDiffClick(Sender:TObject);
                     procedure BtnBraClick(Sender:TObject);
                     procedure BtnDelClick(Sender:TObject);
                     procedure BtnRectClick(Sender:TObject);
                     procedure BtnEditClick(Sender:TObject);
                     procedure BtnSaveClick(Sender:TObject);
                     procedure BtnLoadClick(Sender:TObject);
                     procedure LBoxKeyDown(Sender:TObject;var Key:Word;Shift:TShiftState);
                     procedure ItemTextClick(Sender:TObject);
                     procedure ItemStringClick(Sender:TObject);
                    private
                     RgnList:TStringList;
                     function Indent(S:string):Integer;
                     function CheckExpr(var P:Integer;const S:string):Boolean;
                     function CheckTrans(var P:Integer;const S:string):Boolean;
                     function CheckFactor(var P:Integer;const S:string):Boolean;
                     function ParamToStr(S:string;N:Integer):string;
                     function PolyToStr(S:string):string;
                     function Mnemonic(S:string):string;
                     procedure InsCommand(S:string);
                     function GetRgnString:string;
                     procedure SetRgnString(Value:string);
                    public
                     property RgnString:string read GetRgnString write SetRgnString;
                     function Check(S:string):Boolean;
                   end;

    var RgnEditDlg:TRgnEditDlg;

 implementation

  uses FormRgn,RDRect,RDRound,RDPoly,RDOp,RDExtRgn;

  {$R *.DFM}

   {TRegionProperty}

   function TRegionProperty.GetAttributes;
    begin
     Result:=inherited GetAttributes+[paDialog]
    end;

   procedure TRegionProperty.Edit;
    var Comp:TPersistent;
        I:Integer;
     begin
      with TRgnEditDlg.Create(Application) do
       try
        RgnList:=nil;
        Comp:=GetComponent(0);
        if Comp is TComponent then
         Caption:=(Comp as TComponent).Name+'.'+GetName
        else
         Caption:=GetName;
        RgnList:=TStringList.Create;
        if Comp is TRegionComp then
         with (Comp as TRegionComp).Owner as TForm do
          for I:=0 to ComponentCount-1 do
           if Components[I] is TExternalRegion then
            RgnList.Add(Components[I].Name);
        RgnString:=GetStrValue;
        if ShowModal=mrOK then
         SetStrValue(RgnString)
       finally
        RgnList.Free;
        Free
       end
     end;

   {TRgnEditDlg}

   function TRgnEditDlg.Indent;
    begin
     Result:=StrToInt(Copy(S,1,Pos('|',S)-1))
    end;

   function TRgnEditDlg.CheckExpr;
    begin
     Result:=CheckTrans(P,S);
     while S[P] in ['+','-'] do
      begin
       Inc(P);
       Result:=Result and CheckTrans(P,S)
      end
    end;

   function TRgnEditDlg.CheckTrans;
    begin
     Result:=CheckFactor(P,S);
     while S[P] in ['*','/'] do
      begin
       Inc(P);
       Result:=Result and CheckFactor(P,S)
      end
    end;

   function TRgnEditDlg.CheckFactor;
    var J,D,A:Integer;
     begin
      case UpCase(S[P]) of
       '(':begin
            Inc(P);
            Result:=CheckExpr(P,S);
            if S[P]<>')' then
             Result:=False;
            Inc(P)
           end;
       '-':begin
            Inc(P);
            Result:=CheckFactor(P,S)
           end;
       '0'..'9':begin
                 Val(Copy(S,P,255),A,D);
                 J:=D;
                 Val(Copy(S,P,J-1),A,D);
                 P:=P+J-1;
                 Result:=True
                end;
       'B','C','H','R','W','X','Y':begin
                                    Inc(P);
                                    Result:=True
                                   end
      else
       begin
        Inc(P);
        Result:=False
       end
     end
    end;

   function TRgnEditDlg.Check;
    var P:Integer;
     begin
      P:=1;
      Result:=CheckExpr(P,S+' ');
      if P<>Length(S)+1 then
       Result:=False
     end;

   function TRgnEditDlg.ParamToStr;
    var I,K,P:Integer;
        S2:string;
     begin
      Result:='';
      K:=0;
      for I:=1 to Length(S) do
       if S[I]=',' then
        Inc(K);
      if K<>N-1 then
       Exit;
      S2:=S;
      for I:=1 to K do
       begin
        P:=Pos(',',S2);
        if not Check(Copy(S2,1,P-1)) then
         Exit;
        Delete(S2,1,P)
       end;
      if not Check(S2) then
       Exit;
      Result:=' ('+UpperCase(S)+')'
     end;

   function TRgnEditDlg.PolyToStr;
    var S2,SR,SC:string;
        I,K,P:Integer;
     begin
      Result:='';
      K:=0;
      for I:=1 to Length(S) do
       if S[I]=',' then
        Inc(K);
      if (K<5) or not Odd(K) then
       Exit;
      K:=(K-1) div 2;
      SR:=' ';
      S2:=S;
      for I:=1 to K do
       begin
        P:=Pos(',',S2);
        SC:=Copy(S2,1,P-1);
        if not Check(SC) then
         Exit;
        SR:=SR+'('+UpperCase(SC)+',';
        Delete(S2,1,P);
        P:=Pos(',',S2);
        SC:=Copy(S2,1,P-1);
        if not Check(SC) then
         Exit;
        SR:=SR+UpperCase(SC)+'), ';
        Delete(S2,1,P)
       end;
      P:=Pos(',',S2);
      SC:=Copy(S2,1,P-1);
      if not Check(SC) then
       Exit;
      SR:=SR+'('+UpperCase(SC)+',';
      Delete(S2,1,P);
      if not Check(S2) then
       Exit;
      Result:=SR+UpperCase(S2)+')'
     end;

   function TRgnEditDlg.Mnemonic;
    var P:Integer;
     begin
      if Length(S)=1 then
       case UpCase(S[1]) of
        'A':Result:='Operation AND';
        'D':Result:='Operation Diff';
        'O':Result:='Operation OR';
        'X':Result:='Operation XOR';
        '{':Result:='begin';
        '}':Result:='end'
       else
        Result:=''
       end
      else
       case UpCase(S[1]) of
        'E':begin
             Result:='Ellipse'+ParamToStr(Copy(S,2,Length(S)),4);
             if Length(Result)=7 then
              Result:=''
            end;
        'L':begin
             Result:='Alternate Polygon'+PolyToStr(Copy(S,2,Length(S)));
             if Length(Result)=17 then
              Result:=''
            end;
        'R':begin
             Result:='Rectangle'+ParamToStr(Copy(S,2,Length(S)),4);
             if Length(Result)=9 then
              Result:=''
            end;
        'T':begin
             Result:='External Region (';
             case UpCase(S[2]) of
              'C':Result:=Result+'Center,';
              'L':Result:=Result+'Left,';
              'R':Result:=Result+'Right,'
             end;
             case UpCase(S[3]) of
              'B':Result:=Result+'Bottom), (';
              'C':Result:=Result+'Center), (';
              'T':Result:=Result+'Top), ('
             end;
             Delete(S,1,3);
             P:=Pos(',',S);
             if (P=0) or not Check(Copy(S,1,P-1)) then
              begin
               Result:='';
               Exit
              end;
             Result:=Result+UpperCase(Copy(S,1,P-1))+',';
             Delete(S,1,P);
             P:=Pos(',',S);
             if (P=0) or not Check(Copy(S,1,P-1)) then
              begin
               Result:='';
               Exit
              end;
             Result:=Result+UpperCase(Copy(S,1,P-1))+'), '+Copy(S,P+1,MaxInt)
            end;
        'U':begin
             Result:='RoundRect'+ParamToStr(Copy(S,2,Length(S)),6);
             if Length(Result)=9 then
              Result:=''
            end;
        'W':begin
             Result:='Winding Polygon'+PolyToStr(Copy(S,2,Length(S)));
             if Length(Result)=15 then
              Result:=''
            end
       else
        Result:=''
       end
     end;

   procedure TRgnEditDlg.LBoxDrawItem(Control:TWinControl;Index:Integer;Rect:TRect;State:TOwnerDrawState);
    var P,N:Integer;
        S:string;
     begin
      S:=LBox.Items[Index];
      P:=Pos('|',S);
      N:=StrToInt(Copy(S,1,P-1));
      Delete(S,1,P);
      with (Control as TListBox).Canvas do
       begin
        FillRect(Rect);
        Pen.Style:=psSolid;
        Pen.Color:=clSilver;
        MoveTo(Rect.Left,Rect.Bottom-1);
        LineTo(Rect.Right,Rect.Bottom-1);
        if Length(S)=1 then
         Font.Style:=[fsBold];
        if S<>'' then
         TextOut(Rect.Left+N*10+3,Rect.Top+1,Mnemonic(S));
        Font.Style:=[]
       end
     end;

   procedure TRgnEditDlg.InsCommand;
    var N:Integer;
     begin
      with LBox do
       if ItemIndex>=0 then
        begin
         N:=Indent(Items[ItemIndex]);
         if Odd(N) then
          if Items[ItemIndex][Length(Items[ItemIndex])]='{' then
           Dec(N)
          else
           Inc(N);
         Items.Insert(ItemIndex,IntToStr(N)+'|'+S)
        end
       else
        begin
         Items.Insert(Items.Count-1,'0|'+S);
         ItemIndex:=Items.Count-1
        end
     end;

   procedure TRgnEditDlg.BtnORClick(Sender: TObject);
    begin
     InsCommand('O')
    end;

   procedure TRgnEditDlg.BtnANDClick(Sender: TObject);
    begin
     InsCommand('A')
    end;

   procedure TRgnEditDlg.BtnXORClick(Sender: TObject);
    begin
     InsCommand('X')
    end;

   procedure TRgnEditDlg.BtnDiffClick(Sender: TObject);
    begin
     InsCommand('D')
    end;

   procedure TRgnEditDlg.BtnBraClick(Sender: TObject);
    var N:Integer;
     begin
      with LBox do
       if ItemIndex>=0 then
        begin
         N:=Indent(Items[ItemIndex]);
         if Odd(N) then
          if Items[ItemIndex][Length(Items[ItemIndex])]='{' then
           Dec(N)
          else
           Inc(N);
         Inc(N);
         if N<32 then
          begin
           Items.Insert(ItemIndex,IntToStr(N)+'|{');
           Items.Insert(ItemIndex,IntToStr(N)+'|}');
           ItemIndex:=ItemIndex-1
          end
         else
          ShowMessage('Only 15 embedded blocks are allowed')
        end
     end;

   procedure TRgnEditDlg.BtnDelClick(Sender: TObject);
    var N,I,K,J:Integer;
     begin
      with LBox do
       if (ItemIndex>=0) and (ItemIndex<Items.Count-1) then
        begin
         N:=Indent(Items[ItemIndex]);
         if Odd(N) then
          if Items[ItemIndex][Length(Items[ItemIndex])]='{' then
           if Application.MessageBox('Deleting of the begin statement will involve deleting of the whole block. Continue?','Deleting...',MB_YesNo)=IDYes then
            begin
             I:=ItemIndex+1;
             while Indent(Items[I])>N do
              Inc(I);
             K:=ItemIndex;
             for J:=0 to I-K do
              Items.Delete(K);
             ItemIndex:=K
            end
           else
            begin
            end
          else
           if Application.MessageBox('Deleting of the end statement will involve deleting of the whole block. Continue?','Deleting...',MB_YesNo)=IDYes then
            begin
             I:=ItemIndex-1;
             while Indent(Items[I])>N do
              Dec(I);
             K:=ItemIndex;
             for J:=0 to K-I do
              Items.Delete(I);
             ItemIndex:=I
            end
           else
            begin
            end
         else
          begin
           K:=ItemIndex;
           Items.Delete(ItemIndex);
           ItemIndex:=K
          end
        end
     end;

   procedure TRgnEditDlg.BtnRectClick(Sender: TObject);
    var SR:string;
     begin
      SR:='';
      case (Sender as TComponent).Tag of
       1:begin
          with TRectEditDlg.Create(Self) do
           begin
            SR:=Execute('','Rectangle');
            Free
           end;
          if SR<>'' then
           SR:='R'+SR
         end;
       2:begin
          with TRectEditDlg.Create(Self) do
           begin
            SR:=Execute('','Ellipse');
            Free
           end;
          if SR<>'' then
           SR:='E'+SR
         end;
       3:with TRoundEditDlg.Create(Self) do
          begin
           SR:=Execute('');
           Free
          end;
       4:with TPolyEditDlg.Create(Self) do
          begin
           SR:=Execute('L');
           Free
          end;
       5:with TExtRgnEditDlg.Create(Self) do
          begin
           SR:=Execute('',RgnList);
           Free
          end
      end;
      if SR<>'' then
       InsCommand(SR)
     end;

   procedure TRgnEditDlg.BtnEditClick(Sender: TObject);
    var N,P:Integer;
        S:string;
     begin
      with LBox do
       if (ItemIndex>=0) and (ItemIndex<Items.Count-1) then
        begin
         P:=Pos('|',Items[ItemIndex]);
         N:=StrToInt(Copy(Items[ItemIndex],1,P-1));
         case Items[ItemIndex][P+1] of
          'A','D','O','X':with TOpEditDlg.Create(Self) do
                           begin
                            Items[ItemIndex]:=IntToStr(N)+'|'+Execute(Items[ItemIndex][P+1]);
                            Free
                           end;
          'E':with TRectEditDlg.Create(Self) do
               begin
                S:=Execute(Copy(Items[ItemIndex],P+2,MaxInt),'Ellipse');
                Free;
                if S<>'' then
                 Items[ItemIndex]:=IntToStr(N)+'|E'+S
               end;
          'L','W':with TPolyEditDlg.Create(Self) do
                   begin
                    S:=Execute(Copy(Items[ItemIndex],P+1,MaxInt));
                    Free;
                    if S<>'' then
                     Items[ItemIndex]:=IntToStr(N)+'|'+S
                   end;
          'R':with TRectEditDlg.Create(Self) do
               begin
                S:=Execute(Copy(Items[ItemIndex],P+2,MaxInt),'Rectangle');
                Free;
                if S<>'' then
                 Items[ItemIndex]:=IntToStr(N)+'|R'+S
               end;
          'T':with TExtRgnEditDlg.Create(Self) do
               begin
                S:=Execute(Copy(Items[ItemIndex],P+2,MaxInt),RgnList);
                Free;
                if S<>'' then
                 Items[ItemIndex]:=IntToStr(N)+'|'+S
               end;
          'U':with TRoundEditDlg.Create(Self) do
               begin
                S:=Execute(Copy(Items[ItemIndex],P+2,MaxInt));
                Free;
                if S<>'' then
                 Items[ItemIndex]:=IntToStr(N)+'|'+S
               end
         end
        end
     end;

   function TRgnEditDlg.GetRgnString;
    var I,P:Integer;
     begin
      Result:='';
      for I:=0 to LBox.Items.Count-2 do
       begin
        P:=Pos('|',LBox.Items[I]);
        Result:=Result+Copy(LBox.Items[I],P+1,MaxInt)+#13#10
       end;
      if Result<>'' then
       Delete(Result,Length(Result)-1,2)
     end;

   procedure TRgnEditDlg.SetRgnString;
    var I,P,Ind:Integer;
        Line:string;
        Lines:TStringList;
     begin
      LBox.Items.Clear;
      Lines:=TStringList.Create;
      P:=Pos(#13#10,Value);
      while P>0 do
       begin
        Line:=Copy(Value,1,P-1);
        if Line<>'' then
         Lines.Add(Line);
        Delete(Value,1,P+1);
        P:=Pos(#13#10,Value)
       end;
      if Value<>'' then
       Lines.Add(Value);
      Ind:=0;
      for I:=0 to Lines.Count-1 do
       if Mnemonic(Lines[I])<>'' then
        begin
         case Lines[I][1] of
          'T':begin
               for P:=Length(Lines[P]) downto 1 do
                if Lines[I][P]=',' then
                 Break;
               LBox.Items.Add(IntToStr(Ind)+'|'+UpperCase(Copy(Lines[I],1,P))+Copy(Lines[I],P+1,MaxInt))
              end;
          '{':if Ind<32 then
               begin
                Inc(Ind);
                LBox.Items.Add(IntToStr(Ind)+'|{');
                Inc(Ind)
               end
              else
               begin
                ShowMessage('Only 15 embedded blocks are allowed');
                Break
               end;
          '}':if Ind>0 then
               begin
                Dec(Ind);
                LBox.Items.Add(IntToStr(Ind)+'|}');
                Dec(Ind)
               end
              else
               ShowMessage('''}'' without ''{'' in line '+IntToStr(I))
         else
          LBox.Items.Add(IntToStr(Ind)+'|'+UpperCase(Lines[I]))
         end
        end
       else
        ShowMessage('Unknown command in line '+IntToStr(I));
       while Ind>0 do
        begin
         Dec(Ind);
         LBox.Items.Add(IntToStr(Ind)+'|}');
         Dec(Ind)
        end;
       LBox.Items.Add('0|')
     end;

   procedure TRgnEditDlg.BtnSaveClick(Sender: TObject);
    var F:TextFile;
     begin
      if SDialog.Execute then
       begin
        AssignFile(F,SDialog.FileName);
        Rewrite(F);
        Write(F,RgnString);
        CloseFile(F)
       end
     end;

   procedure TRgnEditDlg.BtnLoadClick(Sender: TObject);
    var F:TextFile;
        SR,S:string;
     begin
      if ODialog.Execute then
       begin
        AssignFile(F,ODialog.FileName);
        Reset(F);
        SR:='';
        while not EOF(F) do
         begin
          Readln(F,S);
          SR:=SR+S+#13#10
         end;
        CloseFile(F);
        if SR<>'' then
         Delete(SR,Length(SR)-1,2);
        RgnString:=SR
       end
     end;

   procedure TRgnEditDlg.LBoxKeyDown(Sender:TObject;var Key:Word;Shift:TShiftState);
    begin
     if (Key=vk_Delete) and (Shift=[]) then
      BtnDelClick(Sender)
    end;

   procedure TRgnEditDlg.ItemTextClick(Sender: TObject);
    begin
     Clipboard.AsText:=RgnString
    end;

   procedure TRgnEditDlg.ItemStringClick(Sender: TObject);
    var I,P:Integer;
        S:string;
     begin
      S:='';
      for I:=0 to LBox.Items.Count-2 do
       begin
        P:=Pos('|',LBox.Items[I]);
        S:=S+''''+Copy(LBox.Items[I],P+1,MaxInt)+'''#13#10'
       end;
      if S<>'' then
       Delete(S,Length(S)-5,6);
      Clipboard.AsText:=S
     end;

 end.
